/*******************************************************************************
 SDemo:
 
 A simple example to illustrate how to use the CUTalk(TM) Cantonese
 Text-To-Speech API to read out user input text.
  
*******************************************************************************
 CHANGE LOG
 13 AUG 2001	-	Created by LO Wai Kit
*******************************************************************************
 IMPORTANT

 To use this sample code, you MUST have be a valid licensee of the CUTalk(TM).
 Otherwise, you MUST REMOVE this program from your computer and any other
 storage.

 This program forms part of the CUTalk(TM). It is provided in the hope that it
 will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*******************************************************************************
 Copyright (C) 2002 CUHK. All rights reserved.
******************************************************************************/

// SDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SDemo.h"
#include "SDemoDlg.h"

#define	MAXBUFLEN	10240

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSDemoDlg dialog

CSDemoDlg::CSDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	//initialisation
	if( initCTTS("C:\\CUTalk\\data", F_VOICE|M_VOICE)==0 ){
		exit(-1);
	}
}

void CSDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSDemoDlg)
	DDX_Control(pDX, IDC_EDIT, m_Edit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CSDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSDemoDlg message handlers

BOOL CSDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSDemoDlg::OnOK() 
{
	inputdata buffer;
	char temp[MAXBUFLEN];
	int i, lc, ll;

	lc = m_Edit.GetLineCount();
	for( i=0; i<lc; i++ ) {
		ll = m_Edit.LineLength(i);
		m_Edit.GetLine(i, temp, MAXBUFLEN);
		temp[ll] = '\0';
		buffer.setcontent(temp);
		chinese2sound(&buffer);
	}
}

void CSDemoDlg::OnCancel() 
{
	//Free the allocated memoery
	termCTTS();	
	
	CDialog::OnCancel();
}
